package com.jcg.redis.msa.controller;

import java.util.List;
import java.util.Optional;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.jcg.redis.msa.model.Event;
import com.jcg.redis.msa.publish.EventPublisher;
import com.jcg.redis.msa.repository.EventRepository;

@RestController
@RequestMapping("/events")
public class EventController {

	@Autowired
	EventPublisher publisher;
	
	@Autowired
	EventRepository repository;

	@PostMapping
	public Event create(@RequestBody Event event) {
		event = repository.save(event);
		try {
			publisher.publish(event);
		} catch (JsonProcessingException e) {
			e.printStackTrace();
		}
		return event;
	}


	@GetMapping("/{id}")
	public Event findById(@PathVariable("id") Long id) {
		Optional<Event> optEvent = repository.findById(id);
		if (optEvent.isPresent()) {
			return optEvent.get();
		} else {
			return null;
		}
	}

	@GetMapping
	public List<Event> findAll() {
		return (List<Event>) repository.findAll();
	}

}
