package com.jcg.redis.msa.model;

import java.io.Serializable;
import java.util.Date;

import org.springframework.data.annotation.Id;
import org.springframework.data.redis.core.RedisHash;

@RedisHash("event")
public class Event implements Serializable {

	private static final long serialVersionUID = 1L;
	
	@Id
	private Long id;
	private Date date;
	private EventStatus status;

	public enum EventStatus {
		NEW, IN_PROGRESS, DONE;
	}
	
	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public Date getDate() {
		return date;
	}

	public void setDate(Date date) {
		this.date = date;
	}

	public EventStatus getStatus() {
		return status;
	}

	public void setStatus(EventStatus status) {
		this.status = status;
	}
	
	@Override
	public String toString() {
		return this.id + "::" + this.date + ":" + this.status;
	}
	
}
