package com.jcg.redis.msa.subscribe;

import java.io.IOException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.connection.Message;
import org.springframework.data.redis.connection.MessageListener;
import org.springframework.stereotype.Service;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.jcg.redis.msa.model.Event;
import com.jcg.redis.msa.repository.EventRepository;

@Service
public class EventSubscriber implements MessageListener {

	private final Logger LOGGER = LoggerFactory.getLogger(EventSubscriber.class);

	@Autowired
	EventRepository repository;
	
	ObjectMapper mapper = new ObjectMapper();

	@Override
	public void onMessage(Message message, byte[] bytes) {
		try {
			Event event = mapper.readValue(message.getBody(), Event.class);
			LOGGER.info("Message received: {}", event.toString());
		} catch (IOException e) {
			LOGGER.error("Error reading message", e);
		}
	}

}
